#include <stdio.h>
#include <stdlib.h>

typedef unsigned int uint32;

#pragma pack(push, 1)
typedef struct
{
	uint32 length;	// NWA t@C̃TCYB
	uint32 offset;	// NWA t@C̊JnItZbgB
	uint32 id;		// ʗp IDB
} nwk_info_t;
#pragma pack(pop)

int main(int argc, char *argv[])
{
	int err_level = 0;

	// ̊mFB
	if(argc != 2) {
		// ȂB
		printf("usage: nwk2nwa filenamne\n");
		err_level = -1;
		return err_level;
	}

	// ̓t@CJB
	FILE *inf = fopen(argv[1], "rb");
	if(!inf) {
		// t@CJȂB
		printf("can't open %s\n", argv[1]);
		err_level = -2;
		return err_level;
	}

	// NWK Ɋ܂܂ NWA ̐ǂݍށB
	uint32 count;
	fread(&count, 1, 4, inf);

	// NWA ̐ɉobt@mۂAnwk_info_t \̂ǂݍށB
	nwk_info_t *nwk_info = new nwk_info_t[count];
	fread(nwk_info, 1, sizeof(nwk_info_t) * count, inf);

	// C[vB
	for(uint32 i = 0; i < count; i++)
	{
		// NWA ̃TCYɉobt@mۂANWA ǂݍށB
		char *buff = new char[nwk_info[i].length];
		fseek(inf, nwk_info[i].offset, SEEK_SET);
		fread(buff, 1, nwk_info[i].length, inf);

		// o̓t@C߂B
		char fname[_MAX_PATH];
		sprintf(fname, "%08X.nwa", nwk_info[i].id);

		// o̓t@CJB
		FILE *outf = fopen(fname, "wb");
		if(!outf) {
			// t@CJȂB
			printf("can't open %s\n", fname);
			err_level = -3;
			break;
		}

		// NWA ށB
		fwrite(buff, 1, nwk_info[i].length, outf);

		// o̓t@CB
		fclose(outf);

		// obt@B
		delete[] buff;
	}

	// ̓t@CB
	fclose(inf);

	// obt@B
	delete[] nwk_info;

	return err_level;
}
